Settings API updates value even if value parameter isn't supplied
Status: Closed   

Priority: Normal   

Assignee: Ondřej Pražák   

Category: Settings   

Target version: 1.10.0   

Difficulty: easy Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/2556

  

Description

When making a PUT to /api/v2/settings/name with an empty hash, the value is changed.  Since #10402 this will change booleans to

false, prior to that you might get an error about downcase!.

GET "/api/v2/settings/Parametrized_Classes_in_ENC" 

value is true

 Now update:

2015-05-19 16:30:54 [I] Started PUT "/api/v2/settings/Parametrized_Classes_in_ENC" for 127.0.0.1 a

t 2015-05-19 16:30:54 +0100

2015-05-19 16:30:54 [I] Processing by Api::V2::SettingsController#update as JSON

2015-05-19 16:30:54 [I]   Parameters: {"setting"=>{}, "apiv"=>"v2", "id"=>"Parametrized_Classes_in

_ENC"}

2015-05-19 16:30:54 [D]    (0.1ms)  UPDATE "settings" SET "value" = '--- false

...

', "updated_at" = '2015-05-19 15:30:54.787404' WHERE "settings"."category" IN ('Setting::Puppet') 

AND "settings"."id" = 28

 And the value has been changed to false.

https://github.com/theforeman/foreman/blob/1.8.0/app/controllers/api/v2/settings_controller.rb#L27 is updating the value without

changing that params even contains a value.

Associated revisions

Revision ee464a8e - 07/20/2015 05:49 PM - Ondřej Pražák

Fixes #10550 - Settings API will not update when value parameter is missing

Revision f3194059 - 07/21/2015 03:50 AM - Dominic Cleal

refs #10550 - extract settings API error string

History

#1 - 07/20/2015 10:50 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2556 added

- Pull request deleted ()

#2 - 07/20/2015 06:01 PM - Ondřej Pražák

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100
https://projects.theforeman.org/issues/10402
https://github.com/theforeman/foreman/blob/1.8.0/app/controllers/api/v2/settings_controller.rb#L27


Applied in changeset ee464a8e1f60a70d71a0d09b96d0b4d37372e499.

#3 - 07/21/2015 03:37 AM - Dominic Cleal

- Assignee set to Ondřej Pražák

- translation missing: en.field_release set to 63
